#!/usr/bin/perl
# indexsoft intuitive mailer
# http://www.indexsoft.com

$|++;
$ENV{'WINDIR'}?($DirSeparator = '\\'):($DirSeparator = '/');
$imlpath = $0; $imlpath =~ s/(subscribe.cgi|subscr~1.cgi)$//gi;
chop $imlpath; $imlpath = '.' if !$imlpath;
push (@INC, $imlpath); push (@INC, "$imlpath/modules");
require "intuitive.pm";

eval('use DBI;'); die("$@\n") if $@;
$SIG{__WARN__} = sub { print "$_[0]\n"; };
$MLDBH = DBI->connect("DBI:mysql:database=$mySQLDBName;host=$mySQLHost",$mySQLUser,$mySQLPassword);
$sth = $MLDBH->prepare("select pname, pvalue from _iml_tune");
$sth -> execute();
${$pname} = $pvalue while (($pname, $pvalue) = $sth->fetchrow_array());

# public mlists
if ($SUSMlists) { $sth = $MLDBH->prepare("select mid, mname from _iml_mlists where mid in ($SUSMlists) order by mid") }
else { $sth = $MLDBH->prepare("select mid, mname from _iml_mlists order by mid") }
$sth -> execute();
$publicmlists .= "$mname (ID:$mid)\n" while (($mid,$mname) = $sth->fetchrow_array());

# mlist name
$sth_mid = $MLDBH->prepare("select mname from _iml_mlists where mid = ?");

eval('use sendmail;'); die("$@\n") if $@;
$sm = new SendMail($SUSSMTP, $SUSSMTPPort);
$sm->setDebug($sm->OFF);

eval('use Mail::POP3Client;'); die("$@\n") if $@;
$pop = new Mail::POP3Client(HOST=>"$SUSPOPHost", AUTH_MODE=>"PASS", DEBUG=>'0');
$pop->User("$SUSPOPLogin");
$pop->Pass("$SUSPOPPassword");
$pop->Connect();
$pop->Message() =~ /^\+OK/i || die('POP auth: '.$pop->Message()."\n");
# messages
for($i = 1; $i <= $pop->Count(); $i++)
{
  foreach( $pop->Head($i) )
  {
    /^From:\s+(.*)/i && ($from = $1);
    /^Subject:\s+(.*)/i && ($subject = $1);
  }
	# users, email and requests
	$from =~ /^(.*)<(.*)>$/?(($uname,$uemail)=($1,$2)):(($uname,$uemail)=($SubscriberName,$from));
	$uname =~ s/\s+$//;
	if (!&CheckEmail($uemail)) { print "skip $uemail($uname) (bad email)\n"; $pop->Delete($i); next; }
	if (lc($uemail) eq lc($SUSEmail)) { print "skip $uemail($uname) (maillist email)\n"; $pop->Delete($i); next; }
	if ($subject =~ /^((?:un|)subscribe)\s+(\d+)$/i) { ($action,$mid)=($1,$2) }
	elsif ($subject =~ /^[^@]*\@((?:un|)subscribe)\s+(\d+)\s+(\d+)$/i) { ($action,$mid,$tstamp)=($1,$2,$3) }
	elsif ($subject =~ /^help$/i) { $action = 'help' }
	else { print "skip $uemail($uname)(bad subject: $subject)\n"; $pop->Delete($i); next; }
	$action = lc($action);
	# mlist name
	if ($action ne 'help')
	{
		$sth_mid -> execute($mid);
		if (!$sth_mid->rows()) { print "skip $uemail($uname) (bad maillist: $mid)\n"; $pop->Delete($i); next; }
		($mlist) = $sth_mid->fetchrow_array();
		if ($SUSMlists and !grep($mid == $_, split(/\,/, $SUSMlists))) { print "skip $uemail($uname) (maillist $mlist ($mid) not public)\n"; $pop->Delete($i); next; }
	}
	# requests
	if ($action eq 'help')
	{
		print "$uemail($uname) send help\n";
		&SendMessage($uname,$uemail,'',"$SUSSubject0",$SUSMessage0);
	}
	elsif ($action eq 'subscribe' and !$tstamp)
	{
		$MLDBH -> do('insert into _iml_users (uname, uemail, uact, subscribed) values ('.$MLDBH->quote($uname).','.$MLDBH->quote($uemail).", '1', NOW())");
		$sth = $MLDBH->prepare("select DATE_FORMAT(subscribed,'%S%m%H%d%Y%i') from _iml_users where uemail=".$MLDBH->quote($uemail));
		$sth -> execute();
		($subscribed) = $sth->fetchrow_array();
		print "$uemail($uname) add subscriber (wait for $subscribed)\n";
		&SendMessage($uname,$uemail,$mlist,"$SUSSubject1 \@subscribe $mid $subscribed",$SUSMessage1);
	}
	elsif ($action eq 'subscribe' and $tstamp)
	{
		print "$uemail($uname) enable subscriber (maillist '$mlist')\n";
		$sth = $MLDBH->prepare('select uid from _iml_users where uemail = '.$MLDBH->quote($uemail)." and DATE_FORMAT(subscribed,'%S%m%H%d%Y%i') = '$tstamp'");
		$sth -> execute();
		if (!$sth->rows()) { print "skip $uemail($uname) (email or code not found)\n"; $pop->Delete($i); next; }
		($uid) = $sth->fetchrow_array();
		$MLDBH -> do("insert into _iml_members (mmid, muid) values ($mid, $uid)");
		&SendMessage($uname,$uemail,$mlist,"$SUSSubject2",$SUSMessage2);
	}
	elsif ($action eq 'unsubscribe' and !$tstamp)
	{
		$sth = $MLDBH->prepare("select DATE_FORMAT(subscribed,'%S%m%H%d%Y%i') from _iml_users where uemail=".$MLDBH->quote($uemail));
		$sth -> execute();
		($subscribed) = $sth->fetchrow_array();
		print "$uemail($uname) request for unsubscribe (wait for $subscribed)\n";
		&SendMessage($uname,$uemail,$mlist,"$SUSSubject3 \@unsubscribe $mid $subscribed",$SUSMessage3);
	}
	elsif ($action eq 'unsubscribe' and $tstamp)
	{
		print "$uemail($uname) unsubscribe (maillist '$mlist')\n";
		$sth = $MLDBH->prepare('select uid from _iml_users where uemail = '.$MLDBH->quote($uemail)." and DATE_FORMAT(subscribed,'%S%m%H%d%Y%i') = '$tstamp'");
		$sth -> execute();
		if (!$sth->rows()) { print "skip $uemail($uname) (email or code not found)\n"; $pop->Delete($i); next; }
		($uid) = $sth->fetchrow_array();
		$MLDBH -> do("delete from _iml_members where mmid = $mid and muid = $uid");
		&SendMessage($uname,$uemail,$mlist,"$SUSSubject4",$SUSMessage4);
	}
	$pop->Delete($i);
}
$pop->Close();



#####################################
sub CheckEmail
{
	($_[0] =~ /^[^\@]+\@[\w\-]+(\.[\w\-]+)+$/)?(return 1):(return '');
}

sub SendMessage
{
	my($uname,$uemail,$mlist,$subject,$body) = @_;
	$subject =~ s/%mlist%/$mlist/g;
	$body =~ s/%name%/$uname/g;
	$body =~ s/%email%/$uemail/g;
	$body =~ s/%mlist%/$mlist/g;
	$body =~ s/%allmlists%/$publicmlists/g;
	$body =~ s/%mlistemail%/$SUSEmail/g;
	$body =~ s/\n/\r\n/g;
	$sm->From($SUSEmail);		$sm->Subject("$subject");		$sm->To("$uname<$uemail>");
	$sm->setMailHeader('X-Mailer', 'indexsoft intuitive mailer (http://www.indexsoft.com)');
	$body .= "\n-------\nSend by indexsoft intuitive mailer (http://www.indexsoft.com)";
	$sm->setMailBody("$body");
	if ($sm->sendMail() != 0) { print "Can not sent to $uemail($uname) (".$sm->{'error'}.")\n" }
	$sm->reset();
}

